% Check current loaded Python version
[~, e, isLoaded] = pyversion;

if isLoaded
    if ~strcmp(e, dense_params.py_exe)
        error('Restart Matlab to load correct python env. \n(%s vs %s)\n', ...
        e, dense_params.py_exe)        
    end 
else
    pyversion(dense_params.py_exe);  % Set to correct env
end

% Add module directory to PYTHONPATH
if count(py.sys.path, dense_params.net_dir) == 0
    insert(py.sys.path,int32(0), dense_params.net_dir);
end

% Load infer module and ensure it's up to date
dense_params.infer_module = py.importlib.import_module(dense_params.infer_script);
py.reload(dense_params.infer_module);
